/**
* Filename: EventSink.java (in org.openbandy.event)
* This file is part of the BandyBasics project.
*
* www.openbandy.org
*/

package org.openbandy.event;

import java.util.Vector;

/**
 * TODO describe purpose and usage
 * 
 * 
 * <br><br>
 * (c) Copyright Philipp Bolliger 2007, ALL RIGHTS RESERVED.
 * 
 * @author Philipp Bolliger (philipp@bolliger.name)
 * @version 1.0
 */
public interface EventSink {
    
    /**
     * While subscribing at the EventRouter, the latter will request
     * the EventSink to state the types of Events it will absorb.
     * 
     * @return A Vector of Strings containing the short class names of the Events.
     */
    public Vector getAbsorbedEventTypes();

    /**
     * This method is called by the EventRouter whenever it
     * has an event this sink subscribed for.
     * 
     * @param event The Event that was forwarded to the sink.
     */
    public void absorb(Event event);
    
    /**
     * Using this callback, the EventRouter will inform subscribed
     * sinks about the loss of the EventSource that formerly generated
     * Events of type <code>eventShortClassName</code>.
     * 
     * @param eventShortClassName The short class name of the Event that will not be generated no more.
     */
    public void lostEventSource(String eventShortClassName);
}
