/**
* Filename: BandyExampleMIDlet.java (in org.openbandy.example)
* This is part of the OpenBandy project.

* @author Philipp Bolliger (philipp@bolliger.name)
* @version 0.9
* 
* (c) Copyright 2007, ALL RIGHTS RESERVED.
*
* A simple example of how to setup a main menu and how to use bandy
* logging facilities in a MIDlet.
*/


package org.openbandy.example;

import javax.microedition.lcdui.Display;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import org.openbandy.service.LogService;
import org.openbandy.ui.MainMenu;

public class BandySimpleExampleMIDlet extends MIDlet {

	protected void startApp() throws MIDletStateChangeException {
		
		/* ***** Mandatory part: Creating the main menu and the logger screen ***** */
		/* assemble the GUI */		
		Display display = Display.getDisplay(this);
		
		/* create main menu and set it as the current screen */
		MainMenu mainMenu = new MainMenu(this, display);
		display.setCurrent(mainMenu);
		
		/* add the log to the main menu */
		mainMenu.addScreen(LogService.getLog());
		
		
		/* A first log message */
		LogService.info(this, "Welcome to Bandy! Enjoy coding..");
	}
	
	protected void destroyApp(boolean unconditional) throws MIDletStateChangeException {
		LogService.debug(this, "Bandy Example MIDlet destroyed");
	}

	protected void pauseApp() {
		LogService.debug(this, "Bandy Example MIDlet pausing..");
	}

}
