package org.openbandy.pref;

/**
 * 
 * TODO describe purpose and usage
 * 
 * a preference is stored as a
 * string according to the following format:
 * 
 * <code>name:value:screenModifiable</code>
 * 
 * @version 1.0
 * @author Philipp Bolliger (philipp@bolliger.name)
 */
public class Preference {
	
	/** The RMS id, 0 if never stored to RMS */
	protected int id = 0;
	
	protected String name = "";
	
	protected String value = "";
	
	protected boolean isScreenModifiable = false;
	
	protected Preference(String name, String value, boolean isScreenModifiable){
		this.name = name;
		this.value = value;
		this.isScreenModifiable = isScreenModifiable;
	}
	
	protected Preference(int id, String prefString){
		this.id = id;
		
		int firstDelimiter = prefString.indexOf(Preferences.DELIMITER);
		int secondDelimiter = prefString.lastIndexOf(Preferences.DELIMITER);
		
		/* name and value */
		this.name = prefString.substring(0, firstDelimiter);
		this.value = prefString.substring(firstDelimiter+1, secondDelimiter);
		
		/* screenModifiable */
		this.isScreenModifiable = false;
		String isScreenModifiableString = prefString.substring(secondDelimiter+1);
		if(isScreenModifiableString.equals(String.valueOf(true))){
			this.isScreenModifiable = true;
		}
	}
	
	protected byte[] getBytes(){
		return (name+Preferences.DELIMITER+value+Preferences.DELIMITER+String.valueOf(isScreenModifiable)).getBytes();
	}
}
