package org.openbandy.ui;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Gauge;

import org.openbandy.service.LogService;



public class ProgressAlert extends Alert {
	
	private Display display;
	
	private Displayable previousDisplayable;
	
	private Gauge progressGauge;
	
	private int maxValue = 0;

	public ProgressAlert(String text, AlertType type, int maxValue) {
		super(null, text, null, type);
		this.maxValue = maxValue;
		
		/* set a very long timeout (20 minutes) */
		setTimeout(20*60*1000);
		
		//TODO bug in 6630 j2me impl: hat maxValue=4, nimmt zwar 1000 an, geht aber sofort rauf auf 4!!!!!
		
		/* create the gauge that shows the process */
		progressGauge = new Gauge(null, false, maxValue, Gauge.INCREMENTAL_UPDATING);
		
		/* set the gauge as indicator */
		setIndicator(progressGauge);
	}

	/**
	 * TODO berall (wo public) javadoc kommentare!!
	 */
	public void show(){
		if(display != null) {
			display.setCurrent(this);
		}
		else {
			LogService.error(this, "Display not set", null);
		}
	}
	
	public void advance(){
		/* increase gauge value */
		progressGauge.setValue(progressGauge.getValue()+1);
		
		/* if the maximum value is reached, dismiss the progress alert */
		if(progressGauge.getValue() == (maxValue-1)){
			dismiss();
		}
	}
	
	public void dismiss(){
		if( (display != null) && (previousDisplayable != null) ){
			display.setCurrent(previousDisplayable);
		}
		else {
			LogService.error(this, "Display or previous displayable not set", null);
		}
	}

	
	/* ******************* Methods for BandyDisplayable *************** */
	
	public void setDisplay(Display display, Displayable previousDisplayable) {
		this.display = display;
		this.previousDisplayable = previousDisplayable;
	}

	public void updateScreen() {
		/* nothing to do */
	}
	
}
